package com.zeroturnaround.javarebel.guice;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Logger;
import org.zeroturnaround.javarebel.LoggerFactory;
import org.zeroturnaround.javarebel.Plugin;
import org.zeroturnaround.javarebel.ReloaderFactory;

import com.google.inject.GuiceComponentReloader;
import com.zeroturnaround.javarebel.guice.cbp.InjectorImplCBP;
import com.zeroturnaround.javarebel.guice.cbp.ScopesCBP;

public class GuicePlugin implements Plugin {
  
	public void preinit() {
		ClassLoader cl = getClass().getClassLoader();

		ReloaderFactory
		.getInstance()
		.addClassReloadListener(
				new GuiceComponentReloader());

		IntegrationFactory
		.getInstance()
		.addIntegrationProcessor(
				cl, 
				"com.google.inject.InjectorImpl", 
				new InjectorImplCBP());

		IntegrationFactory
		.getInstance()
		.addIntegrationProcessor(
				cl, 
				"com.google.inject.Scopes", 
				new ScopesCBP());		
	}

	public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
	  return crs.getClassResource("com.google.inject.Injector") != null;
	}
	
	public String getId() {
	  return "guice_plugin";
	}
	
	public String getName() {
	  return "Google Guice Plugin";
	}
	
	public String getDescription() {
	  return "Supports adding new components and injecting new implicit dependencies. Singletons are reconfigured if their class changes.";
	}
}
